	@program	prog_code,prog_name

;************** Start of Fargo program ***************

prog_code:
	jsr	flib[clr_scr]
	jsr	romlib[reset_link]

	lea	($400000),a4
	move.w	#8,-(a7)
	pea	buffer(pc)
dump_loop:
	clr.l	d1
	clr.l	d2
	move.l	a4,d0
	move.w	#7,d4
	jsr	hexlib[put_hex]

test_key:
	tst.w	($75B0)
	beq	no_key
	move.w	($75B2),d0
	clr.w	($75B0)
	cmp.w	#$0108,d0
	beq	dump_exit
no_key:
	jsr	romlib[tx_free]
	cmp.w	#8,d0
	bcs	test_key

	lea	(buffer+8)(pc),a0

	move.b	3(a4),d0
	asl.l	#8,d0
	move.b	4(a4),d0
	asl.l	#8,d0
	move.b	5(a4),d0
	asl.l	#8,d0
	move.b	6(a4),d0

	move.w	#3,d1
bit_loop_1:
	move.b	d0,d2
	or.b	#$80,d2
	move.b	d2,-(a0)
	asr.l	#7,d0
	dbf.w	d1,bit_loop_1

	move.b	(a4),d0
	asl.l	#8,d0
	move.b	1(a4),d0
	asl.l	#8,d0
	move.b	2(a4),d0
	asl.l	#8,d0
	move.b	3(a4),d0
	asr.l	#4,d0

	move.w	#3,d1
bit_loop_2:
	move.b	d0,d2
	or.b	#$80,d2
	move.b	d2,-(a0)
	asr.l	#7,d0
	dbf.w	d1,bit_loop_2

	jsr	romlib[transmit]

	add.l	#7,a4
	cmp.l	#$500000,a4
	bcs	dump_loop
dump_exit:
	add.l	#$6,a7
	rts

;*****************************************************

buffer:
	dcb.b	8,0

prog_name:
	dc.b	"Dump ROM to link port (ASCII)",0
	ds.w	0

;*************** End of Fargo program ****************

	reloc_open
	add_library	romlib
	add_library	flib
	add_library	hexlib
	reloc_close
	end
